
// sound module include
#include <Wtv020sd16p.h>
#include "DHDCC.h"

// variables 

// for dcc
DHDCC DccDecoder;

// for sound

int sound_resetPin = 3;  // The pin number of the reset pin.
int sound_clockPin = 4;  // The pin number of the clock pin.
int sound_dataPin = 5;  // The pin number of the data pin.
int sound_busyPin = 0;  // The pin number of the busy pin.

Wtv020sd16p wtv020sd16p(sound_resetPin,sound_clockPin,sound_dataPin,sound_busyPin);
  
// for welding arc effect
byte weldingarc_timeout1;
byte weldingarc_timeout2;
byte weldingarc_last1;
byte weldingarc_last2;
long weldingarc_last_time1;
long weldingarc_last_time2;
byte weldingarc_pin1;
byte weldingarc_pin2;

bool effectson=false;
bool lasteffectson=false;
long effectslast=0;

void setup() {

  Serial.begin(9600);
  
  DccDecoder.DecoderSetup(2); // use pin 2 for dcc signal input from "DCC-to-logical-level" converter!!!!
  
  wtv020sd16p.reset();
  
  // welding arc
  weldingarc_pin1=6; // pin 6
  weldingarc_pin2=7; // pin 7
  
  pinMode(weldingarc_pin1, OUTPUT);
  pinMode(weldingarc_pin2, OUTPUT);
  
  //some init for welding arc effect
  weldingarc_timeout1=random (10, 45);
  weldingarc_timeout2=random (10, 45);
  weldingarc_last1=LOW;
  weldingarc_last2=LOW;
  weldingarc_last_time1=millis();
  weldingarc_last_time2=millis();
  effectslast=millis()-5000;

}

void loop() {

  if(DccDecoder.GetOutputState(0)){
    if(effectson==false && (millis()-effectslast>500)){
      Serial.println("Welding on");
      effectson=true;
      effectslast=millis();
      wtv020sd16p.asyncPlayVoice(1);
    }else{
      if(millis()-effectslast>500){
        Serial.println("Welding off");
        effectson=false;       
        effectslast=millis();
        wtv020sd16p.stopVoice();
      }
    }
  }

  weldingarc(effectson);  
  
  
}



void weldingarc(bool globalmode){

  if(!globalmode){
      digitalWrite(weldingarc_pin1, LOW);
      digitalWrite(weldingarc_pin2, LOW);
      weldingarc_last1==HIGH;
      weldingarc_last2==HIGH;
    return;  
  }
  if((millis()-weldingarc_last_time1)>weldingarc_timeout1){

    if(weldingarc_last1==LOW){
      digitalWrite(weldingarc_pin1, HIGH);
      weldingarc_last1=HIGH;  
    }else{
      digitalWrite(weldingarc_pin1, LOW);  
      weldingarc_last1=LOW;  
    }
     weldingarc_last_time1=millis();
     weldingarc_timeout1=random (5, 35);
  }

  if((millis()-weldingarc_last_time2)>weldingarc_timeout2){

    if(weldingarc_last2==LOW){
      digitalWrite(weldingarc_pin2, HIGH);
      weldingarc_last2=HIGH;  
    }else{
      digitalWrite(weldingarc_pin2, LOW);  
      weldingarc_last2=LOW;  
    }
     weldingarc_last_time2=millis();
     weldingarc_timeout2=random (5, 35);
  }
  
}
